
<!-- Warning: This file has been autogenerated by tools/makedoc.py. Manual edits will be overwritten. -->
<html>
    <head>
        <title>freesmartphone.org Audio Interface</title>
        <link rel="stylesheet" type="text/css" href="http://git.freesmartphone.org/?p=specs.git;a=blob_plain;f=html/style.css;hb=HEAD" />
    </head>
    <body>
    <div class="topbox">freesmartphone.org Framework DBus Interface Specification</div>


<h1>org.freesmartphone.Device.Audio</h1><h2>Description</h2>
<p>This interface provides access to notification sounds, sound scenarios, and mixer controls.</p>
<h2>Namespace</h2>
<p><tt>org.freesmartphone.Device.Audio</tt></p>
<h2>Methods</h2><ul>
<li><a href="#PlaySound">PlaySound</a></li>
<li><a href="#StopSound">StopSound</a></li>
<li><a href="#StopAllSounds">StopAllSounds</a></li>
<li><a href="#GetAvailableScenarios">GetAvailableScenarios</a></li>
<li><a href="#GetScenario">GetScenario</a></li>
<li><a href="#SetScenario">SetScenario</a></li>
<li><a href="#PushScenario">PushScenario</a></li>
<li><a href="#PullScenario">PullScenario</a></li>
<li><a href="#SaveScenario">SaveScenario</a></li>
<li><a href="#GetVolume">GetVolume</a></li>
<li><a href="#SetVolume">SetVolume</a></li>
</ul>
<h2>Signals</h2><ul>
<li><a href="#SoundStatus">SoundStatus</a></li>
<li><a href="#Scenario">Scenario</a></li>
</ul>
<h2>Properties</h2><i>None</i>
<h2>Errors</h2><ul>
<li><a href="#UnknownFormat">UnknownFormat</a></li>
<li><a href="#PlayerError">PlayerError</a></li>
<li><a href="#NotPlaying">NotPlaying</a></li>
<li><a href="#AlreadyPlaying">AlreadyPlaying</a></li>
<li><a href="#ScenarioInvalid">ScenarioInvalid</a></li>
<li><a href="#ScenarioStackUnderflow">ScenarioStackUnderflow</a></li>
<li><a href="#DeviceFailed">DeviceFailed</a></li>
</ul>
<h1>Methods</h1><h3><a name="PlaySound">PlaySound</a> ( sii )</h3>
<p><i>Description:</i> Play a sound resource. </p><h4>Parameters</h4><i>s: name</i><p>The identification of the sound resource. Will be treated as filename, if no schema is given.  Format-specific options may be supplied by appending multiple ";foo=bar" statements to the  filename. Player engines that do not support these options should ignore them. </p><i>i: loop</i><p>Loop. Set this to 1, if you want the sound resource to be restarted, once it ends. 0, otherwise. </p><i>i: length</i><p>Length in seconds. Set this to anything other than 0 if you want to override the length of the sound resource.  Note that some audio resources have no concept of length or do know when the sound resource ends.  In these cases, you have to provide a reasonable length value or the sound will play endlessly. </p>
<h3><a name="StopSound">StopSound</a> ( s )</h3>
<p><i>Description:</i> Stop playing a sound resource. </p><h4>Parameters</h4><i>s: name</i><p>The identification of the sound resource. Will be treated as filename, if no schema is given. </p>
<h3><a name="StopAllSounds">StopAllSounds</a> ( )</h3><p><i>Description:</i> Stop all currently played sound resources. </p>
<h3><a name="GetAvailableScenarios">GetAvailableScenarios</a> ( ) &rarr; as</h3>
<p><i>Description:</i> Returns a list of supported audio scenarios. </p><h4>Returns</h4><i>as: scenarios</i><p>The supported audio scenarios. </p>
<h3><a name="GetScenario">GetScenario</a> ( ) &rarr; s</h3>
<p><i>Description:</i> Get the current audio scenario. </p><h4>Returns</h4><i>s: scenario</i><p>The name of the scenario. </p>
<h3><a name="SetScenario">SetScenario</a> ( s )</h3>
<p><i>Description:</i> Set a new audio scenario. </p><h4>Parameters</h4><i>s: scenario</i><p>The name of the scenario. </p>
<h3><a name="PushScenario">PushScenario</a> ( s )</h3>
<p><i>Description:</i> Push a new audio scenario onto the stack and active it. </p><h4>Parameters</h4><i>s: scenario</i><p>The new active scenario. </p>
<h3><a name="PullScenario">PullScenario</a> ( ) &rarr; s</h3>
<p><i>Description:</i> Pull an audio scenario from the stack and activate the next one. </p><h4>Returns</h4><i>s: scenario</i><p>The new active scenario. </p>
<h3><a name="SaveScenario">SaveScenario</a> ( s )</h3>
<p><i>Description:</i> Save the current scenario as a file. </p><h4>Parameters</h4><i>s: scenario</i><p>The name of the scenario. </p>
<h3><a name="GetVolume">GetVolume</a> ( ) &rarr; y</h3>
<p><i>Description:</i> Get the current main audio volume. </p><p><div class="rationale"><p>The main volume can depend on the current scenario. A change of scenario may change the main volume as well. </p></div></p><h4>Returns</h4><i>y: volume</i><p>The volume in percent (0-100). </p>
<h3><a name="SetVolume">SetVolume</a> ( y )</h3>
<p><i>Description:</i> Set the new main audio volume. </p><p><div class="rationale"><p>The main volume can depend on the current scenario. A change of scenario may change the main volume as well. </p></div></p><h4>Parameters</h4><i>y: volume</i><p>The volume in percent (0-100). </p>
<h1>Signals</h1><h3><h3><a name="SoundStatus">SoundStatus</a> ( ssa{sv} )</h3><p><i>Description:</i> Sent whenever a sound has been started or stopped. </p><h4>Parameters</h4><i>s: id</i><p>The identification of sound resource that changed its status. </p><i>s: status</i><p>The new status for the sound resource. </p><i>a{sv}: properties</i><p>An array of property values. Note that properties are optional. Expected tuples are:  <ul>  <li>...to be defined...</li>  </ul> </p></h3>
<h3><h3><a name="Scenario">Scenario</a> ( ss )</h3><p><i>Description:</i> Sent whenever there is a change of the global sound scenario. </p><h4>Parameters</h4><i>s: scenario</i><p>The scenario that is now active. </p><i>s: reason</i><p>The reason for this change. Expected reasons are:  <ul>  <li>...to be defined...</li>  </ul> </p></h3>
<h1>Errors</h1><h3><a name="UnknownFormat">UnknownFormat</a></h3><p><i>Description:</i> Raised, if the audio format is not supported. </p>
<h3><a name="PlayerError">PlayerError</a></h3><p><i>Description:</i> Raised, if the player emits an (internal) error. </p>
<h3><a name="NotPlaying">NotPlaying</a></h3><p><i>Description:</i> Raised, if the audio file is not playing. </p>
<h3><a name="AlreadyPlaying">AlreadyPlaying</a></h3><p><i>Description:</i> Raised, if the audio file is already playing. </p>
<h3><a name="ScenarioInvalid">ScenarioInvalid</a></h3><p><i>Description:</i> Raised, if the audio scenario can not be activated. </p>
<h3><a name="ScenarioStackUnderflow">ScenarioStackUnderflow</a></h3><p><i>Description:</i> Raised, if there is no more scenario to pull from the stack. </p>
<h3><a name="DeviceFailed">DeviceFailed</a></h3><p><i>Description:</i> Raised, if the audio device reported a problem. </p>

    <hr/>
    <small>
    | Specified 2008-2012 by the <a href="http://www.freesmartphone.org">Freesmartphone.org</a> team. | Join us and discuss further drafts smartphones-standards (at) linuxtogo (dot) org
    </small>
    <hr/>
    </body>
</html>

